﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Reversi
{
    public partial class Form1 : Form
    {
        
        private const int margines = 10;
        private Color[] koloryPól = { Color.LightGray, Color.Orange, Color.YellowGreen };

        private ReversiSilnik silnik = new ReversiSilnik(1, 8, 8);
        private Button[,] planszaWidok;

        private void twórzPlanszę()
        {
            planszaWidok = new Button[8, 8];

            int bokPlanszy = Math.Min(this.Width, this.Height);
            bokPlanszy -= 2 * margines;
            int bokPola = bokPlanszy / 9;

            for(int poziomo = 0; poziomo < planszaWidok.GetLength(0); ++poziomo)
                for(int pionowo = 0; pionowo < planszaWidok.GetLength(1); ++pionowo)
                {
                    Button b = new Button();
                    b.Width = bokPola;
                    b.Height = bokPola;
                    b.Left = margines + poziomo * bokPola;
                    b.Top = margines + pionowo * bokPola;
                    b.Parent = this;
                    b.Click += polePlanszy_Click;
                    b.Tag = new Tuple<int, int>(poziomo, pionowo);
                    //b.Text = poziomo.ToString() + ", " + pionowo.ToString();
                    planszaWidok[poziomo, pionowo] = b;
                }
        }

        private void polePlanszy_Click(object sender, EventArgs e)
        {
            Tuple<int, int> pole = ((sender as Button).Tag as Tuple<int, int>);
            if (pole == null) throw new Exception("Brak danych o współrzędnych pola");
            silnik.PołóżKamień(pole.Item1, pole.Item2);
            pokażPlanszę();
        }        

        private void pokażPlanszę()
        {
            for (int poziomo = 0; poziomo < planszaWidok.GetLength(0); ++poziomo)
                for (int pionowo = 0; pionowo < planszaWidok.GetLength(1); ++pionowo)
                {
                    planszaWidok[poziomo, pionowo].BackColor = 
                        koloryPól[silnik.PobierzStanPola(poziomo, pionowo)];
                }

            btnKolorGraczaWykonującegoRuch.BackColor =
                        koloryPól[silnik.NumerGraczaWykonującegoNastępnyRuch];
        }

        public Form1()
        {
            InitializeComponent();

            twórzPlanszę();
            pokażPlanszę();

            //int wynik = silnik.PołóżKamień(4, 2);
            //pokażPlanszę();
        }
    }
}
